exec("Add-Ons/System_SimplexGen2D/SGen2D_GUI.gui");
exec("Add-Ons/System_SimplexGen2D/Support_Updater.cs");

if(!$SGen2D_KeyBind)
{
	$remapDivision[$remapCount] = "Simplex Gen: 2D";

	$remapName[$remapCount] = "2D Gen Main GUI";
	$remapCmd[$remapCount] = "SGen2D_GUI_Toggle";
	$remapCount++;
	
	$SGen2D_KeyBind = true;
}

function SGen2D_GUI_Toggle(%toggle)
{
	if(%toggle && isObject(SGen2D_GUI))
	{
		if(SGen2D_GUI.isAwake())
			canvas.popDialog(SGen2D_GUI);
		else
		{
			if(!SGen2D_ColSelGUI.colSwSetup) SGen2D_GUI_SetupPalette();
			if(!SGen2D_ColSelGUI.initSetup) SGen2D_FindProxyColors();
			SGen2D_ColSelGUI.setVisible(false);
			
			canvas.pushDialog(SGen2D_GUI);
		}
	}
}

///////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////

function SGen2D_GUI_TabSwitch(%tab)
{
	switch$(%tab)
	{
		case "Main":
		
			SGen2D_GUI_TabMain.setBitmap("base/client/ui/tab1use");
			SGen2D_GUI_TabFtrs.setBitmap("base/client/ui/tab1");
			SGen2D_GUI_TabAdv.setBitmap("base/client/ui/tab1");
			
			SGen2D_GUI_WndwMain.setVisible(true);
			SGen2D_GUI_WndwFtrs.setVisible(false);
			SGen2D_GUI_WndwAdv.setVisible(false);
		
		case "Features":
		
			SGen2D_GUI_TabMain.setBitmap("base/client/ui/tab1");
			SGen2D_GUI_TabFtrs.setBitmap("base/client/ui/tab1use");
			SGen2D_GUI_TabAdv.setBitmap("base/client/ui/tab1");
			
			SGen2D_GUI_WndwMain.setVisible(false);
			SGen2D_GUI_WndwFtrs.setVisible(true);
			SGen2D_GUI_WndwAdv.setVisible(false);
		
		case "Advanced":
		
			SGen2D_GUI_TabMain.setBitmap("base/client/ui/tab1");
			SGen2D_GUI_TabFtrs.setBitmap("base/client/ui/tab1");
			SGen2D_GUI_TabAdv.setBitmap("base/client/ui/tab1use");
			
			SGen2D_GUI_WndwMain.setVisible(false);
			SGen2D_GUI_WndwFtrs.setVisible(false);
			SGen2D_GUI_WndwAdv.setVisible(true);
	}
}

///////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////

function SGen2D_GUI_HelpMsg(%msg)
{
	switch$(%msg)
	{
		case "BrickUIN":
			CLIENTCMDMessageBoxOk("Simplex Gen: 2D - Help","The UI name for the main brick used for terrain; make sure the name is spelled correctly and that the brick itself exists.");
		case "TerrainSize":
			CLIENTCMDMessageBoxOk("Simplex Gen: 2D - Help","The size (in meters) of the generated terrain grid, based on the X, Y and Z-axis. It's recommended to use values for X and Y that are relative to the water brick size: 16 meters. The Z-axis value is for the max terrain height.");
		case "TerrainOffset":
			CLIENTCMDMessageBoxOk("Simplex Gen: 2D - Help","The offset position (in meters) from the origin in which terrain generates. It's recommended to use values for X and Y that are relative to the water brick size: 16 meters.");
		case "Seed":
			CLIENTCMDMessageBoxOk("Simplex Gen: 2D - Help","The seed changes how the terrain generates. Both positive and negative integer values can be used, if 8 characters or less. The \"Rand\" button can also be used to randomly choose a seed value for you.");
		case "GrassColor":
			CLIENTCMDMessageBoxOk("Simplex Gen: 2D - Help","The main color used for terrain bricks above the sand level.");
		case "DirtColor":
			CLIENTCMDMessageBoxOk("Simplex Gen: 2D - Help","The color of fill bricks that generate below the terrain (fill bricks under the sand level will be the same color as the terrain itself).");
		case "SandColor":
			CLIENTCMDMessageBoxOk("Simplex Gen: 2D - Help","The color for terrain bricks that generate underneath the sand level you specify.");
		case "WaterColor":
			CLIENTCMDMessageBoxOk("Simplex Gen: 2D - Help","The color for the 32x water bricks, based on the water level you set.");
		case "SandLevel":
			CLIENTCMDMessageBoxOk("Simplex Gen: 2D - Help","The height (in meters) which causes bricks below that level to adopt the sand color you specify; set to 0 to disable.");
		case "WaterLevel":
			CLIENTCMDMessageBoxOk("Simplex Gen: 2D - Help","The height (in meters) in which water bricks are added to the terrain as it generates below that level; set to 0 to disable.");
		case "SnapBrH":
			CLIENTCMDMessageBoxOk("Simplex Gen: 2D - Help","A toggle option that will cause terrain bricks to snap to a height level relative to it's Z-size. For instance, if you're using the 4x Cube brick which is 2 meters tall, cubes will snap to every 2 meters on the Z-axis.");
		case "NoiseItrs":
			CLIENTCMDMessageBoxOk("Simplex Gen: 2D - Help","The amount of layers of noise to overlay when calculating the resultant terrain (similar to overlaying hills on top of each other); more noise passes means more detail for the terrain, but will also take longer to calculate.");
		case "MainItr":
			CLIENTCMDMessageBoxOk("Simplex Gen: 2D - Help","The main reference size for the starting iteration, which is subdivided and added back into itself at various scales.");
		case "ItrSubDScale":
			CLIENTCMDMessageBoxOk("Simplex Gen: 2D - Help","The scale by which to divide the main iteration size. For instance, if the main iteration size is 512, and the subdivide scale is 2, then 512 will be divided by 2 each time for every iteration - depending on the number of noise pass iterations used.");
		case "FillBrAmount":
			CLIENTCMDMessageBoxOk("Simplex Gen: 2D - Help","The amount of fill bricks (if any) to add underneath the main terrain brick (setting this value to 0 will prevent generating any fill bricks, which can help reduce the overall brickcount).");
		case "PublicBr":
			CLIENTCMDMessageBoxOk("Simplex Gen: 2D - Help","Toggles adding generated bricks to the public brickgroup (public bricks can't be modified by players once planted).");
	}
}

///////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////

function SGen2D_GUI_UploadSettings()
{
	%seed = SGen2D_GUI_Seed.getValue();
	%size = SGen2D_GUI_TerSizeX.getValue() SPC SGen2D_GUI_TerSizeY.getValue() SPC SGen2D_GUI_TerSizeZ.getValue();
	%offset = SGen2D_GUI_TerOffX.getValue() SPC SGen2D_GUI_TerOffY.getValue() SPC SGen2D_GUI_TerOffZ.getValue();
	
	%brData =	SGen2D_GUI_BrUIName.getValue() TAB
				SGen2D_GUI_GrassColor.colorID TAB
				SGen2D_GUI_DirtColor.colorID TAB
				SGen2D_GUI_SandColor.colorID TAB
				SGen2D_GUI_WaterColor.colorID TAB
				SGen2D_GUI_SandLevel.getValue() TAB
				SGen2D_GUI_WaterLevel.getValue() TAB
				SGen2D_GUI_FillBrAm.getValue();
				
	%itr = SGen2D_GUI_MainItrSize.getValue() SPC SGen2D_GUI_NoiseItrs.getValue() SPC SGen2D_GUI_ItrSDivScale.getValue();
	%snapToBr = SGen2D_GUI_SnapBrH.getValue();
	%publicBr = SGen2D_GUI_PublicBr.getValue();
	
	commandToServer('SGen2D_UploadSettings',%seed,%size,%offset,%brData,%itr,%snapToBr,%publicBr);
}

///////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////

function SGen2D_GUI_SetupPalette()
{
	for(%rowY = 0; %rowY < 8; %rowY++)
	{
		for(%colX = 0; %colX < 8; %colX++)
		{
			%colStr = getColorIDtable(%colID);
			
			%pos = 4 + (24 * %colX) SPC 4 + (24 * %rowY);
			%colStr = getColorI(%colStr);
			%alpha = mClamp(getWord(%colStr,3),0,255);
			
			if(%alpha <= 0) //end of color table
				return;
			
			//Opaque Colors
			if(%alpha == 255)
			{
				%colObj = new GuiSwatchCtrl()
				{
					profile = "GuiDefaultProfile";
					position = %pos;
					extent = "24 24";
					color = %colStr;

					new GuiBitmapButtonCtrl()
					{
						profile = "GuiDefaultProfile";
						position = "0 0";
						extent = "24 24";
						command = "SGen2D_GUI_ColSelect(\"" @ %colID @ "\",\"" @ %colStr @ "\",\"\",\"Select\");";
						text = " ";
						bitmap = "base/client/ui/btnColor";
						mColor = "0 0 0 255";
					};
				};
			}
			
			//Transparent Colors
			else
			{
				%colObj = new GuiBitmapCtrl()
				{
					profile = "GuiDefaultProfile";
					position = %pos;
					extent = "24 24";
					bitmap = "Add-Ons/System_SimplexGen2D/TransSw";

					new GuiSwatchCtrl()
					{
						profile = "GuiDefaultProfile";
						position = "0 0";
						extent = "24 24";
						color = %colStr;
					};
					new GuiBitmapButtonCtrl()
					{
						profile = "GuiDefaultProfile";
						position = "0 0";
						extent = "24 24";
						command = "SGen2D_GUI_ColSelect(\"" @ %colID @ "\",\"" @ %colStr @ "\",\"\",\"Select\");";
						text = " ";
						bitmap = "base/client/ui/btnColor";
						mColor = "0 0 0 255";
					};
				};
			}

			SGen2D_ColSelGUI_SwPalette.add(%colObj);
			%colID++;
		}
	}
	
	SGen2D_ColSelGUI.colSwSetup = true;
}

///////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////

function SGen2D_FindProxyColors()
{
	%grassResMin = 2.0;
	%dirtResMin = 2.0;
	%sandResMin = 2.0;
	%waterResMin = 2.0;
	
	%grassCol = "0.000000 0.501961 0.231373 1.000000";
	%dirtCol = "0.313726 0.239216 0.113725 1.000000";
	%sandCol = "0.803922 0.666667 0.486275 1.000000";
	%waterCol = "0.113725 0.564706 1.000000 0.694118";
	
	for(%d = 0; %d < 64; %d++)
	{
		%newColorStr = getColorIDTable(%d);
		
		for(%e = 0; %e < 4; %e++)
		{
			switch(%e)
			{
				case 0:
					%oldColorStr = %grassCol;
					%resMin = %grassResMin;
				case 1:
					%oldColorStr = %dirtCol;
					%resMin = %dirtResMin;
				case 2:
					%oldColorStr = %sandCol;
					%resMin = %sandResMin;
				case 3:
					%oldColorStr = %waterCol;
					%resMin = %waterResMin;
			}

			%tmpMin = vectorDist(%newColorStr,%oldColorStr);
			%transCond = mabs(getWord(%newColorStr,3) - getWord(%oldColorStr,3)) < 0.3;  //credit to SpaceGuy's script for this part; slightly modified
			%applyCol = false;
			
			if(%tmpMin < %resMin && %transCond)
			{
				switch(%e)
				{
					case 0:
						%newGrassColID = %d;
						%newGrassColStr = %newColorStr;
						%grassResMin = %tmpMin;
					case 1:
						%newDirtColID = %d;
						%newDirtColStr = %newColorStr;
						%dirtResMin = %tmpMin;
					case 2:
						%newSandColID = %d;
						%newSandColStr = %newColorStr;
						%sandResMin = %tmpMin;
					case 3:
						%newWaterColID = %d;
						%newWaterColStr = %newColorStr;
						%waterResMin = %tmpMin;
				}
			}
		}
	}

	if(%newGrassColStr $= "1.000000 0.000000 1.000000 0.000000" || %newGrassColStr $= "0.000000 0.000000 0.000000 0.000000")
		%newGrassColID = 0;
	if(%newDirtColStr $= "1.000000 0.000000 1.000000 0.000000" || %newDirtColStr $= "0.000000 0.000000 0.000000 0.000000")
		%newDirtColID = 0;
	if(%newSandColStr $= "1.000000 0.000000 1.000000 0.000000" || %newSandColStr $= "0.000000 0.000000 0.000000 0.000000")
		%newSandColID = 0;
	if(%newWaterColStr $= "1.000000 0.000000 1.000000 0.000000" || %newWaterColStr $= "0.000000 0.000000 0.000000 0.000000")
		%newWaterColID = 0;
	
	SGen2D_GUI_GrassColor.colorID = %newGrassColID;
	SGen2D_GUI_GrassColor.color = getColorI(%newGrassColStr);
	SGen2D_GUI_DirtColor.colorID = %newDirtColID;
	SGen2D_GUI_DirtColor.color = getColorI(%newDirtColStr);
	SGen2D_GUI_SandColor.colorID = %newSandColID;
	SGen2D_GUI_SandColor.color = getColorI(%newSandColStr);
	SGen2D_GUI_WaterColor.colorID = %newWaterColID;
	SGen2D_GUI_WaterColor.color = getColorI(%newWaterColStr);
	
	SGen2D_ColSelGUI.initSetup = true;
}

///////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////

function SGen2D_GUI_ColSelect(%colID,%colStr,%obj,%action)
{
	switch$(%action)
	{
		case "Open":
		
			SGen2D_ColSelGUI.setVisible(true);
			SGen2D_GUI.pushToBack(SGen2D_ColSelGUI);
			
			SGen2D_ColSelGUI.ColObj = %obj;
	
		case "Select":
		
			SGen2D_ColSelGUI.ColObj.colorID = %colID;
			SGen2D_ColSelGUI.ColObj.color = %colStr;
			
			SGen2D_ColSelGUI.setVisible(false);
	}
}

///////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////

package SGen2D_ClientPackage
{
	function disconnect(%bool)
	{
		SGen2D_ColSelGUI.colSwSetup = false;
		SGen2D_ColSelGUI.ColObj = "";
		SGen2D_ColSelGUI_SwPalette.clear();
		
		return parent::disconnect(%bool);
	}
};
activatePackage(SGen2D_ClientPackage);