$Pref::Server::Smplx2D::Seed = 53137;									// +/- integer
$Pref::Server::Smplx2D::Size = "256 256 100";							//Generation grid size on X Y and Z (all in meters)
$Pref::Server::Smplx2D::Offset = "0 0 20";								//Grid offset position on X Y and Z (all in meters)
$Pref::Server::Smplx2D::BrData = "brick4xCubeData 2 2 2 0 1 2 3 70 68";	//Brick datablock, brick size X Y and Z (meters), grass dirt sand and water colorIDs
$Pref::Server::Smplx2D::BrFillData = "brick4xCubeData 2 1";				//Fill / dirt brick datablock, brick size Z (meters), amount of fill bricks
$Pref::Server::Smplx2D::Iterations = "512 3 2";							//Main iteration size, # of iterations, iteration subdivide scale
$Pref::Server::Smplx2D::SnapToBrH = true;								//Force bricks to snap their height to be relative to their Z-Size
$Pref::Server::Smplx2D::Public = true;									//Toggle public ownership

// "/SGen2DStart" begins generation (it's usually best to use the GUI "Apply & Start" button however, unless you manually set up terrain colors for "$Pref::Server::Smplx2D::BrData")
// "/SGen2DHalt" stops generation.
// "/SGen2DClear" clears only generated bricks.

//It's recommended to enable Brick_Large_Cubes when using the generator, although it's not required (using the cube bricks for terrain is also recommended)
//Make sure you don't leave your dedicated server during generation
//Terrain bricks can overlap (the generator doesn't detect collision prior to planting bricks) so be sure to clear previous terrain or to offset new terrain if needed

///////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////

function SERVERCMDSGen2D_UploadSettings(%cl,%seed,%size,%offset,%brData,%itr,%snapToBr,%publicBr)
{
	if(%cl.isLocalConnection() || %cl.bl_id == getNumKeyID())
	{
		if(isObject(%cl.player))
		{
			%brUIN = getField(%brData,0);
			
			if(isObject(%brDB = $uiNameTable[%brUIN]))
			{
				$Pref::Server::Smplx2D::Seed = %seed;
				$Pref::Server::Smplx2D::Size = %size;
				$Pref::Server::Smplx2D::Offset = %offset;
				$Pref::Server::Smplx2D::Iterations = %itr;
				$Pref::Server::Smplx2D::SnapToBrH = %snapToBr;
				$Pref::Server::Smplx2D::Public = %publicBr;
			
				//Set up datablock and brick size information
				$Pref::Server::Smplx2D::BrData = setWord($Pref::Server::Smplx2D::BrData,0,%brDB.getName()); //use getName method for when pref var is saved
				$Pref::Server::Smplx2D::BrData = setWord($Pref::Server::Smplx2D::BrData,1,(%brSzX = %brDB.brickSizeX) * 0.5);
				$Pref::Server::Smplx2D::BrData = setWord($Pref::Server::Smplx2D::BrData,2,(%brSzY = %brDB.brickSizeY) * 0.5);
				$Pref::Server::Smplx2D::BrData = setWord($Pref::Server::Smplx2D::BrData,3,%brDB.brickSizeZ * 0.2);
				
				//Set up color IDs and levels
				$Pref::Server::Smplx2D::BrData = setWord($Pref::Server::Smplx2D::BrData,4,getField(%brData,1)); //grass color
				$Pref::Server::Smplx2D::BrData = setWord($Pref::Server::Smplx2D::BrData,5,getField(%brData,2)); //dirt color
				$Pref::Server::Smplx2D::BrData = setWord($Pref::Server::Smplx2D::BrData,6,getField(%brData,3)); //sand level
				$Pref::Server::Smplx2D::BrData = setWord($Pref::Server::Smplx2D::BrData,7,getField(%brData,4)); //sand color
				$Pref::Server::Smplx2D::BrData = setWord($Pref::Server::Smplx2D::BrData,8,getField(%brData,5)); //water level
				$Pref::Server::Smplx2D::BrData = setWord($Pref::Server::Smplx2D::BrData,9,getField(%brData,6)); //water color
				
				//Fill brick datablock, size and fill amount
				//if(%brSzX == %brSzY)
				//{
				//	if(isObject(%tmpDB = "brick" @ %brSzX @ "x" @ %brSzX @ "Data"))
				//		%fillBrDB = %tmpDB;
				//	if(isObject(%tmpDB = "brick" @ %brSzX @ "xCubeData"))
				//		%fillBrDB = %tmpDB;
				//	if(isObject(%tmpDB = "brick" @ %brSzX @ "x" @ %brSzX @ "3" @ "Data"))
				//		%fillBrDB = %tmpDB;
				//	if(%fillBrDB $= "")
				//		%fillBrDB = %brDB; //if relative cube brick can't be found, use terrain brick datablock instead
				//}
				//else
					%fillBrDB = %brDB;
				
				$Pref::Server::Smplx2D::BrFillData = setWord($Pref::Server::Smplx2D::BrFillData,0,%fillBrDB.getName()); //use getName method for when pref var is saved
				$Pref::Server::Smplx2D::BrFillData = setWord($Pref::Server::Smplx2D::BrFillData,1,%fillBrDB.brickSizeZ * 0.2);
				$Pref::Server::Smplx2D::BrFillData = setWord($Pref::Server::Smplx2D::BrFillData,2,getField(%brData,7));
				
				SERVERCMDSGen2DStart(%cl);
			}
			else
				centerPrint(%cl,"Simplex Gen 2D: The terrain brick UI name \"" @ %brUIN @ "\" is invalid; associated datablock can't be found.",4);
		}
		else
			centerPrint(%cl,"Simplex Gen 2D: Please wait until you spawn.",2);
	}
}

///////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////

function SERVERCMDSGen2DStart(%cl)
{
	if(%cl.isLocalConnection() || %cl.bl_id == getNumKeyID())
	{
		if(isObject(%cl.player))
		{
			if(!$SGen2D_generating)
			{
				if(!$SGen2D_clearing)
				{
					if(isObject(getWord($Pref::Server::Smplx2D::BrData,0)))
					{
						if(!isObject(SGen2D_SimSet)) new SimSet("SGen2D_SimSet");
						
						if($Pref::Server::Smplx2D::Public)
							%clBG = "BrickGroup_888888";
						else
							%clBG = getBrickGroupFromObject(%cl);
						
						%tStart = getSimTime();
						%xStart = getWord($Pref::Server::Smplx2D::BrData,1) * 0.5;
						%yStart = getWord($Pref::Server::Smplx2D::BrData,2) * 0.5;
						
						$SGen2D_generating = true;
						deleteVariables("$SGen2D_WatGenArr*");
						messageClient(%cl,'',"\c2> Simplex Gen 2D: Routine Started.");
						
						SGen2D_GenRoutine(%cl,%clBG,%tStart,%xStart,%yStart);
					}
					else
						centerPrint(%cl,"Simplex Gen 2D: The terrain brick datablock \"" @ %brDB @ "\" is invalid.",4);
				}
				else
					centerPrint(%cl,"Simplex Gen 2D: Terrain is currently being cleared, please wait.",2);
			}
			else
				centerPrint(%cl,"Simplex Gen 2D: A generation routine is already running.",2);
		}
		else
			centerPrint(%cl,"Simplex Gen 2D: Please wait until you spawn.",2);
	}
}

///////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////

function SERVERCMDSGen2DHalt(%cl)
{
	if(%cl.isLocalConnection() || %cl.bl_id == getNumKeyID())
	{
		if(isObject(%cl.player))
		{
			if($SGen2D_generating)
			{
				messageClient(%cl,'',"> Simplex Gen 2D: Routine Halted.");
				$SGen2D_generating = false;
			}
			else
				centerPrint(%cl,"Simplex Gen 2D: No generation routine is currently running.",2);
		}
		else
			centerPrint(%cl,"Simplex Gen 2D: Please wait until you spawn.",2);
	}
}

///////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////

function SERVERCMDSGen2DClear(%cl)
{
	if(%cl.isLocalConnection() || %cl.bl_id == getNumIDKey() && isObject(SGen2D_SimSet))
	{
		if(isObject(%cl.player))
		{
			if(!$SGen2D_generating)
			{
				if(!$SGen2D_clearing)
				{
					%brCount = SGen2D_SimSet.getCount();
					$SGen2D_clearing = true;
					SGen2D_ClearRoutine(%cl,%brCount);
				}
				else
					centerPrint(%cl,"Simplex Gen 2D: Terrain is already being cleared.",2);
			}
			else
				centerPrint(%cl,"Simplex Gen 2D: A generation routine is currently running; please halt it first or wait for it to finish.",2);
		}
		else
			centerPrint(%cl,"Simplex Gen 2D: Please wait until you spawn.",2);
	}
}

///////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////

function SGen2D_GenRoutine(%cl,%clBG,%tStart,%x,%y)
{
	%itrRefSize = getWord($Pref::Server::Smplx2D::Iterations,0);
	%itrCount = getWord($Pref::Server::Smplx2D::Iterations,1);
	%itrSDiv = getWord($Pref::Server::Smplx2D::Iterations,2);
	%zMod = mFloor(getWord($Pref::Server::Smplx2D::Size,2));
	
	%xB = %x + getWord($Pref::Server::Smplx2D::Offset,0);
	%yB = %y + getWord($Pref::Server::Smplx2D::Offset,1);
	%HVtot = 0;
	
	for(%c = 0; %c < %itrCount; %c++)
	{
		%HV = SGen2D_RandNumGen(%xB,%yB,%itrRefSize,%zMod);
		
		if($Pref::Server::Smplx2D::SnapToBrH)
		{
			%brZsize = getword($Pref::Server::Smplx2D::BrData,3);
			%HV = mFloor(%HV / %brZsize) * %brZsize;
		}
			
		%HVtot += %HV;
		%itrRefSize /= %itrSDiv;
		%zMod /= %itrSDiv;
	}
	
	SGen2D_PlantBr(%cl,%clBG,%x SPC %y SPC %HVtot);
	
	if($SGen2D_generating)
	{
		if((%x += getWord($Pref::Server::Smplx2D::BrData,1)) >= getWord($Pref::Server::Smplx2D::Size,0))
		{
			%x = getWord($Pref::Server::Smplx2D::BrData,1) * 0.5;
			
			if((%y += getWord($Pref::Server::Smplx2D::BrData,2)) >= getWord($Pref::Server::Smplx2D::Size,1))
			{
				messageClient(%cl,'',"\c1> Simplex Gen 2D: Routine Complete! Time Elapsed: \c6" @ (getSimTime() - %tStart) / 1000 @ "s \c1Total Bricks Used: \c6" @ SGen2D_SimSet.getCount());
				deleteVariables("$SGen2D_generating");
				
				return;
			}
		}
		
		scheduleNoQuota(0,0,SGen2D_GenRoutine,%cl,%clBG,%tStart,%x,%y);
	}
}

///////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////

function SGen2D_ClearRoutine(%cl,%brCount)
{
	if((%sCount = SGen2D_SimSet.getCount()) > 0)
	{
		%fillBrAm = getWord($Pref::Server::Smplx2D::BrFillData,2);
		
		if(%sCount >= (%fillBrAm + 1))
		{
			for(%c = 0; %c < (%fillBrAm + 1); %c++)
				if(isObject(%tmpObj = SGen2D_SimSet.getObject(0))) 
					%tmpObj.delete();
		}
		else
			SGen2D_SimSet.getObject(0).delete();
		
		scheduleNoQuota(0,0,SGen2D_ClearRoutine,%cl,%brCount);
	}
	else
	{
		messageClient(%cl,'',"\c3> Simplex Gen 2D: \c6" @ %brCount @ " \c3terrain bricks cleared.");
		deleteVariables("$SGen2D_clearing");
	}
}

///////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////

function SGen2D_RandNumGen(%x,%y,%itrSize,%ZMod)
{
	%seed = $Pref::Server::Smplx2D::Seed;
	
	%xRela = mFloor(%x / %itrSize) * %itrSize;
	%xRelb = %xRela + %itrSize;
	%yRela = mFloor(%y / %itrSize) * %itrSize;
	%yRelb = %yRela + %itrSize;

	%PosXa = (((%xRela + 13333227 + %seed) % 99999) * 13313) % %zMod;
	%PosXb = (((%xRelb + 13333227 + %seed) % 99999) * 13313) % %zMod;
	%PosYa = (((%yRela + 49979687 + %seed) % 99999) * 15551) % %zMod;
	%PosYb = (((%yRelb + 49979687 + %seed) % 99999) * 15551) % %zMod;
	
	%corBL = mAbs(%PosXa - %PosYa);
	%corTL = mAbs(%PosXa - %PosYb);
	%corBR = mAbs(%PosXb - %PosYa);
	%corTR = mAbs(%PosXb - %PosYb);

	%Co = (%y - %yRela) / %itrSize; //about 30ms faster (on average) than using modulus: "(%x % %itrSize) / %itrSize"
	%Sm = (6 * mPow(%Co,5)) - (15 * mPow(%Co,4)) + (10 * mPow(%Co,3));
	%slopeYa = %corBL - ((%corBL - %corTL) * %Sm);
	%slopeYb = %corBR - ((%corBR - %corTR) * %Sm);
	
	%Co = (%x - %xRela) / %itrSize; 
	%Sm = (6 * mPow(%Co,5)) - (15 * mPow(%Co,4)) + (10 * mPow(%Co,3));
	%HV = %slopeYa - ((%slopeYa - %slopeYb) * %Sm);
	
	return %HV;
}

///////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////

function SGen2D_PlantBr(%cl,%clBG,%pos)
{
	%brPos = vectorAdd(%pos,$Pref::Server::Smplx2D::Offset);
	%brPosZ = getWord(%brPos,2);
	
	%brSnapH = getWord($Pref::Server::Smplx2D::BrData,3) * 0.5;
	%brPosF = vectorAdd(%brPos,0 SPC 0 SPC %brSnapH); //snap to plate height (does this automatically, but we need to account for it for fill layer below)
	
	if(%brPosZ < getWord($Pref::Server::Smplx2D::BrData,8))
		%grassCol = %dirtCol = getWord($Pref::Server::Smplx2D::BrData,6);
	else
	{
		%grassCol = getWord($Pref::Server::Smplx2D::BrData,4);
		%dirtCol = getWord($Pref::Server::Smplx2D::BrData,5);
	}
	if(%brPosZ < getWord($Pref::Server::Smplx2D::BrData,9))
		sGen2D_WaterGen(%cl,%clBG,%brPosF);
	
	
	//Main Brick
	%brMain = new fxDTSbrick()
	{
		position = %brPosF;
		rotation = "1 0 0 0";
		datablock = getWord($Pref::Server::Smplx2D::BrData,0);
		
		angleID = 0;
		colorID = %grassCol;
		
		isPlanted = true;
		client = %cl;
		stackBL_ID = %cl.bl_id;
		
		SGen2D = true;
		SGen2D_Generated = true;
	};
	
	%clBG.add(%brMain);
	SGen2D_SimSet.add(%brMain);
	%brMain.setTrusted(1);
	%brMain.plant();
	
	%brMain.isBasePlate = true; //doesn't work if set up as field above
	%brMain.willCauseChainKill();
	
	
	//Fill Brick
	if((%fillBrAm = getWord($Pref::Server::Smplx2D::BrFillData,2)) > 0)
	{
		%fillBrSnapH = getWord($Pref::Server::Smplx2D::BrFillData,1) * 0.5;
		%newBrPos = vectorSub(%brPos,0 SPC 0 SPC %fillBrSnapH);
		
		for(%c = 0; %c < %fillBrAm; %c++)
		{
			%brFill = new fxDTSbrick()
			{
				position = vectorSub(%newBrPos,0 SPC 0 SPC getWord($Pref::Server::Smplx2D::BrFillData,1) * %c);
				rotation = "1 0 0 0";
				datablock = getWord($Pref::Server::Smplx2D::BrFillData,0);
				
				angleID = 0;
				colorID = %dirtCol;
				
				isPlanted = true;
				client = %cl;
				stackBL_ID = %cl.bl_id;
				
				SGen2D = true;
				SGen2D_Generated = true;
			};
			
			%clBG.add(%brFill);
			SGen2D_SimSet.add(%brFill);
			%brFill.setTrusted(1);
			%brFill.plant();
			
			%brFill.isBasePlate = true; //doesn't work if set up as field above
			%brFill.willCauseChainKill();
		}
	}
}

///////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////

function SGen2D_WaterGen(%cl,%clBG,%brPosF)
{
	%watPosX = (mFloor(getWord(%brPosF,0) / 16) * 16) + 8;
	%watPosY = (mFloor(getWord(%brPosF,1) / 16) * 16) + 8;
	%watPosZ = getWord($Pref::Server::Smplx2D::BrData,9) - 2;
	
	if(!$SGen2D_WatGenArr[%watPosX SPC %watPosY])
	{
		$SGen2D_WatGenArr[%watPosX SPC %watPosY] = true;
		%watCol = getWord($Pref::Server::Smplx2D::BrData,7);
		%brRefPosZ = getWord(%brPosF,2);
		%topLayer = true;
		
		for(%c = %watPosZ; (%c + 4) > %brRefPosZ; %c -= 4)
		{
			%brWat = new fxDTSbrick()
			{
				position = %watPosX SPC %watPosY SPC %c;
				rotation = "1 0 0 0";
				datablock = brick32xWaterData;
				
				angleID = 0;
				colorID = %watCol;
				
				isPlanted = true;
				client = %cl;
				stackBL_ID = %cl.bl_id;
				
				SGen2D = true;
				SGen2D_Generated = true;
			};
			
			%clBG.add(%brWat);
			SGen2D_SimSet.add(%brWat);
			%brWat.setTrusted(1);
			%brWat.plant();
			%brWat.createWaterZone();
			
			%brWat.isBasePlate = true; //doesn't work if set up as field above
			%brWat.willCauseChainKill();
			
			if(!%topLayer)
				%brWat.setRendering(0);
			
			%topLayer = false;
		}
	}
}

///////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////

package SGen2D_ServerPackage
{
	function HammerImage::onHitObject(%this,%obj,%slot,%col,%d,%e)
	{
		if(isObject(%col) && isObject(%obj) && %col.SGen2D_Generated)
		{
			if(isObject(%cl = %obj.client) && %obj.getClassName() $= "Player")
				centerPrint(%cl,"Simplex Gen 2D: Terrain can only be destroyed by using the Destructo / Admin Wand",3);
			
			ServerPlay3D(hammerHitSound,%col.getPosition());
			return;
		}
		
		return parent::onHitObject(%this,%obj,%slot,%col,%d,%e);
	}
	
	////////////////////////////////////////////////////////////////////////////////////////////////////
	
	function WandImage::onHitObject(%this,%obj,%slot,%col,%d,%e)
	{
		if(isObject(%col) && isObject(%obj) && %col.SGen2D_Generated)
		{
			if(isObject(%cl = %obj.client) && %obj.getClassName() $= "Player")
				centerPrint(%cl,"Simplex Gen 2D: Terrain can only be destroyed by using the Destructo / Admin Wand",3);

			return;
		}
		
		return parent::onHitObject(%this,%obj,%slot,%col,%d,%e);
	}
	
	////////////////////////////////////////////////////////////////////////////////////////////////////
	
	function AdminWandImage::onHitObject(%this,%obj,%slot,%col,%d,%e)
	{
		if(isObject(%col) && isObject(%obj) && %col.SGen2D_Generated)
		{
			%cl = %obj.client;
			%isPub = getBrickGroupFromObject(%col).getName() $= "BrickGroup_888888";
			
			if(%isPub && !%cl.destroyPublicBricks)
			{
				if(isobject(%cl) && %obj.getClassName() $= "Player")
					centerPrint(%cl,"Simplex Gen 2D: Use the \c6/DPB \c0chat command to enable destruction of public bricks for the Admin Wand",5);
				
				return;
			}
		}
		
		return parent::onHitObject(%this,%obj,%slot,%col,%d,%e);
	}
};
activatePackage(SGen2D_ServerPackage);